Subject: comp.lang.tcl Frequently Asked Questions (May 31, 1996) (3/5)
From: [email-masked] (Larry W. Virden)
Newsgroups: comp.lang.tcl.announce,comp.lang.tcl,comp.lang.perl.tk,comp.answers,news.answers

Archive-name: tcl-faq/part3
Comp-lang-tcl-archive-name: tcl-faq.part03
Version: 7.000
Last-modified: May 31, 1996

	For more information concerning Tcl (see "tcl-faq/part1"),
(see "tcl-faq/part2"), (see "tcl-faq/part4") or (see "tcl-faq/part5").

Index of questions:

XI. Where can I get these packages?
	A. Tcl and Tk
	B. The Tcl/Tk User Contributions Archive
	C. Expect available via e-mail.
	D. EMACS modes for Tcl
	E. The tk toolbox project (obsolete)
	F. [tv]grind definitions for tcl/tk/expect
	G. BNF style notation for Tcl
	H. Tcl/Tk Quick Reference Cards
	I. Hilit 19 Tcl mode
	J. HTML versions of Tcl man pages and FAQ.
	K. Japanese translation of Tk 3.6 manuals
	L. Latex styles for the Tcl/Tk Workshop 94.
	M. Tcl References for various platforms
	N. The "How do I speed up a Tcl/Tk application" doc
	O. http files without a WWW client
	P. The patch command
	Q. Source code from published books
	R. Documentation relating to Perl's Tk interface
	S. Tutorials on various subjects

End of FAQ Index

----------------------------------------------------------------------

------------------------------

From: FAQ Tcl/Tk Package Catalog
Subject: -XI- Where can I get these packages?

Tcl and Extended Tcl have been posted to comp.sources.misc in the past,
appearing In volume 25 and then Tcl appeared again in volume 26 and can
be found at most comp.sources.misc archive sites in the tcl and tclx
directories.  These are quite old versions actually, but are still usable.

A few of the sites which either mirror the Tcl/Tk submissions or have special
versions are:

<URL:ftp://ftp.sunlabs.com/pub/tcl/> :- official home of Tcl/Tk base code
<URL:ftp://ftp.neosoft.com/pub/tcl/> :- official home for comp.lang.tcl
					contributed sources archive

<URL:ftp://syd.dit.csiro.au/pub/tk/> :- shadow of the user contrib and base

<URL:ftp://iskut.ucs.ubc.ca/pub/X11/tcl/>

<URL:ftp://ftp.switch.ch/mirror/tcl/>

<URL:ftp://ftp.cs.tu-berlin.de/pub/tcl/> :- Does not seem to be answering
<URL:ftp://ftp.Germany.EU.net/pub/programming/tools/tcl/>
<URL:ftp://ftp.hrz.uni-kassel.de/pub/tcl/> :- base
<URL:ftp://ftp.informatik.tu-muenchen.de/pub/comp/programming/languages/tcl/>
<URL:ftp://ftp.mpi-sb.mpg.de/pub/tcl/>
<URL:ftp://ftp.tu-bs.de/pub/languages/tcl/>
<URL:ftp://ftp.uni-paderborn.de/unix/tcl/>

<URL:ftp://ftp.funet.fi/pub/languages/tcl/> :- user archive

<URL:ftp://ftp.ibp.fr/pub/tcl/> :- shadow of base,user,expect,
	ak, tkwin, and comp.lang.tcl archive
<URL:ftp://ftp.jussieu.fr/pub/tcl/>

<URL:ftp://ftphost.comp.vuw.ac.nz/> :- VUW

<URL:ftp://ftp.sra.co.jp/pub/lang/tcl/>
<URL:ftp://oskgate0.mei.co.jp/free/X/toolkits/tcl/> :- shadow of ftp.cs only

<URL:ftp://ftp.ncc.up.pt/pub/tcl/code/> :- some code mirrored

<URL:ftp://ftp.luth.se/pub/languages/tcl/> :- some code mirrored
<URL:ftp://ftp.sunet.se/pub/lang/tcl/> :- some code mirrored

<URL:ftp://src.doc.ic.ac.uk/packages/tcl/tcl-archive/> :- shadow of user archive
<URL:ftp://src.doc.ic.ac.uk/usenet/news.answers/comp.lang.tcl/> :- shadow of
	FAQs
<URL:ftp://unix.hensa.ac.uk/pub/yggdrasil/usr/lib/xf-2.3/>

<URL:ftp://mirror.neosoft.com/pub/tcl/alcatel/> :- the original home of user
						contribution archive
<URL:ftp://ftp.cs.columbia.edu/pub/archives/tcl/> :- shadow of user, etc.
<URL:ftp://ftp.neosoft.com/pub/tcl/distrib/> :- original home of TclX
<URL:ftp://ftp.sterling.com/programming/languages/tcl/>
<URL:ftp://ftp.uu.net/languages/tcl/> :- shadow of base code only
<URL:ftp://gatekeeper.dec.com/pub/UCB/tcl/sprite/> :- shadow of base only

<URL:ftp://sunsite.unc.edu/pub/Linux/> :- contains port of extended Tcl and
					extended Tk to this OS.
<URL:ftp://sunsite.unc.edu/pub/languages/tcl/>

<URL:ftp://ftp.cs.uoregon.edu/pub/tcl/> :- shadow of ftp.sunlabs.com/pub/tcl

<URL:ftp://ftp.rge.com/pub/tcl/>

Note also that there are a number of CD-ROMs now available with a snapshot
of various Tcl archive sites on them.  (See "tcl-faq/bibliography/part1")
for details.

------------------------------

From: -XI- Where can I get these packages?
Subject: -A- Tcl and Tk

From <URL:ftp://ftp.sunlabs.com/pub/tcl/README>:

This directory contains a collection of files related to Tcl and
Tk, all of which are available for anonymous FTP.  Below is a
description of what is in the various files in this directory:

vcmakes.a2.tar.Z -	This file contains the Visual C++ makefiles for
			Tcl 7.5a2 and Tk 4.1a2.

vcmakes.a2.tar.gz -	Same as vcmakes.a2.tar.Z except compressed with gzip
			instead of compress.

tk4.1a2.tar.Z -		This is the most recent release of Tk.  It is
			the second alpha release of Tk 4.1, which supports
			Windows and Mac platforms.  It was released on
			October 6, 1995, and includes the sources for the
			Tk library and the "wish" windowing shell, plus
			reference manual entries and a number of demonstration
			scripts.

tk4.1a2.tar.gz -	Same as tk4.1a2.tar.Z except compressed with gzip
			instead of compress.

tk4.1a2.patch.gz -	Compressed patch file that will upgrade from Tk 4.1a1
			to Tk 4.1a2.  For instructions on applying, see
			<URL:http://www.sunlabs.com/research/tcl/4.0.html>.

tcl7.5a2.tar.Z -	This is the most recent release of Tcl.  It is
			the second alpha release of Tcl 7.5, which supports
			Windows and Mac platforms.  It was released on
			October 6, 1995, and includes the sources for the
			Tcl library and the "tclsh" application, plus
			reference manual entries.

tcl7.5a2.tar.gz -	Same as tcl7.5a2.tar.Z except compressed with gzip
			instead of compress.

tcl7.5a2.patch.gz -	Compressed patch file that will upgrade from Tcl 7.5a1
			to Tcl 7.5a2.  For instructions on applying, see
			<URL:http://www.sunlabs.com/research/tcl/4.0.html>.

win41a2.exe -		Pre-compiled binaries of Tk 4.1a2 and Tcl 7.5a2
			for Windows (Win32s, Windows 95, or Windows NT).
			Execute this file on a PC and it runs an
			installation script to extract and install the
			Tcl and Tk libraries, wish, plus library files
			and documentation.

w32s125.exe -		This self-extracting archive contains the
			setup files for Win32s v1.25, which is needed when
			running Tcl and Tk on PCs under Windows 3.1.
			Execute this file on a Windows 3.1 PC to extract
			the Win32s setup files.  Once this is done, run
			the new setup.exe file to install the Win32s system.

win31-sample-ext.tar.Z	This file contains a sample Tcl extension for
			Borland C++ 4.5.

vcmakes.a2.tar.Z -	This file contains the Visual C++ makefiles for
			Tcl 7.5a2 and Tk 4.1a2.

mactk4.1a2.sea.hqx -	Pre-compiled binaries of Tk 4.1a2 and Tcl 7.5a2
			for the Macintosh (both 68k & PowerPC platforms).
			The file is in binhex format, which is understood
			by Fetch, StuffIt, and many other Mac utilities.
			The unpacked file is a self-installing archive:
			double-click on it and it will create a folder
			containing all you need to run Tcl/Tk on a Macintosh.

mac -			This subdirectory contains several other useful
			things for the Macintosh, such as source releases
			organized for easy installation on Macs.

tk4.0.tar.Z -		This is the newest stable release of the Tk
			toolkit, released in July 1995.  It includes
			the sources or the Tk library and the "wish"
			windowing shell, plus reference manual entries
			and a number of demonstration scripts.

tk4.0.tar.gz -		Same as tk4.0.tar.Z except compressed with gzip
			instead of compress.

tk4.0p1.patch.gz -	Compressed patch file that fixes several bugs
			found in Tk 4.0.  Released July 29, 1995.  See
			<URL:http://www.sunlabs.com/research/tcl/4.0.html>
			for instructions on applying.

tk4.0p2.patch.gz -	Compressed patch file that fixes several bugs
			found in Tk 4.0.  Released September 19, 1995.
			See <URL:http://www.sunlabs.com/research/tcl/4.0.html>
			for instructions on applying.

tcl7.4.tar.Z -		This is the newest stable release of the Tcl
			scripting language, released in July 1995.  It
			includes the sources for the Tcl library and the
			"tclsh" application, plus reference manual entries.

tcl7.4.tar.gz -		Same as tcl7.4.tar.Z except compressed with gzip
			instead of compress.

tcl7.4p1.patch.gz -	Compressed patch file that fixes several bugs
			found in Tcl 7.4.  Released July 29, 1995.  See
			<URL:http://www.sunlabs.com/research/tcl/4.0.html>
			for instructions on applying.

tcl7.4p2.patch.gz -	Compressed patch file that fixes several bugs
			found in Tcl 7.4.  Released September 19, 1995.
			See <URL:http://www.sunlabs.com/research/tcl/4.0.html>
			for instructions on applying.

SpecTcl-0.1a.tar.Z
SpecTcl-0.1a.tar.gz	These files contain the alpha release of SpecTcl,
			a graphical user interface builder for TK.  SpecTcl
			requires TK4.1a2 to run, as well as a modified
			version of the BLT blt_table geometry manager, which
			is included in the release.  The releases without the
			"a" were missing a couple of files and have been
			withdrawn.

SpecTcl-0.1_patch_a.gz This is a gzipped patch file to upgrade
			SpecTcl-0.1.tar.gz to SpecTcl-0.1a.tar.gz.  cd to
			SpecTcl-0.1, and pipe the patch file to
			gunzip | patch -p1

html_library-0.3.tar.gz Enhanced version of html_library-0.1.tar.gz
			Supports all HTML/2.0 features, including
			forms.

mx.tar.Z -		Sources and documentation for a mouse-based text
			editor (mx) and terminal emulator (tx) based on
			Tcl.  This is a very old release: it uses an old
			version of Tcl (which is included) and doesn't
			even use Tk; it uses an ancient toolkit called
			"Sx".  These tools will eventually be replaced
			with new tools based on Tk and the newest Tcl.

mx-2.5.tar.Z - 		Newer version of mx (see above) that uses the
			standard X selection mechanism rather than the
			homegrown mechanism used by previous versions.
			Version 2.5 is not backwards compatible with
			previous versions (you can't cut and paste between
			the two). Still uses sx and an old version of
			Tcl (both of which are included).

mx-2.5.patch.Z -	Patch file for converting mx 2.4 sources into 2.5.
			Invoke patch in the top-level mx directory
			with the "-p1" switch and an uncompressed version of
			this file, e.g. "patch -p1 < mx-2.5.patch".

engManual.tar.Z -	Compressed tar file for a directory containing
			the Tcl/Tk Engineering Manual, which describes
			the coding and testing conventions used to develop
			Tcl and Tk.  I strongly encourage other Tcl/Tk
			developers to follow these conventions, particularly
			if you want to submit code for possible inclusion
			into official releases.

book.examples.Z -	Compressed file containing ASCII text for nearly all				of the examples from the book "Tcl and the Tk Toolkit".

tclUsenix90.ps -	Postscript for a paper on Tcl that appeared in the
			Winter 1990 USENIX Conference.

tkUsenix91.ps -		Postscript for a paper on Tk that appeared in the
			Winter 1991 USENIX Conference.

tkF10.ps -		Postscript for Figure 10 of the Tk paper.

tut.tar.Z -		A collection of materials from a full-day tutorial
			on Tcl and Tk.  Includes viewgraphs from four
			one-hour talks.

In addition, there may be older releases of some or all of the above
files; look for files with earlier release numbers.

Be sure to retrieve files in image mode (type "type image" to FTP)
in order to make sure that you don't lose bits.

Most of these files are compressed tar files; to get back the
original directory hierarchies, type a command like the following for
each file you retrieved:
		zcat tk4.0.tar.Z | tar xf -
This will create a directory named tk4.0 with all the source files and
documentation for that release.  For files with ".gz" extensions, use
a command like the following instead of the one above:
		gunzip -c tk4.0.tar.gz | tar xf -

Each of the releases has a README file in the top-level directory that
describes how to compile the release, where to find documentation, etc.

In addition to the information here, there are many other Tcl/Tk extensions,
scripts, and applications in the Tcl contributed archive, which is
currently located at <URL:ftp://ftp.neosoft.com/pub/tcl/>.

There is also a collection of Web pages on Tcl and Tk at the URL
<URL:http://www.sunlabs.com/research/tcl/>.

Questions or problems with any of these distributions should be directed
to <URL:news:comp.lang.tcl>.

SCCS Id: @(#) README 1.7 95/10/11 11:05:01

Any file with a .gz extension is a file compressed with gzip, the GNU
portable compression standard.  Get a copy from to
<URL:ftp://prep.ai.mit.edu/pub/gnu/>.  For example, to uncompress tk4.0.tar.gz,
type

    gunzip tk4.0.tar.gz

once you've retrieved the file.  This will produce a file named "tk4.0.tar".

------------------------------

From: -XI- Where can I get these packages?
Subject: -B- The Tcl/Tk User Contributions Archive

Contributions to the Tcl/Tk Contrib Archive are most welcome --
please upload them to:

	<URL:ftp://ftp.neosoft.com/pub/tcl/incoming/>

send the archive maintainer <URL:mailto:[email-masked]> a
note stating the names of the files you uploaded and a brief description
for the index.  Otherwise, you must upload a README.filename along with
your upload.  Otherwise, your contribution probably won't get into the
archives.

Users without FTP capability should use one of the following mail-based
FTP services (send mail to the appropriate address with "help" in the
body):

BITNET users:	BITFTP <URL:mailto:[email-masked]>
Others:		<URL:mailto:[email-masked]> (DEC ftpmail)
Europe:		<URL:mailto:[email-masked]>
		<URL:mailto:[email-masked]>

WARNING!  The archive maintainer will NOT be automatically archiving anything
posted to comp.lang.tcl or previously to the mailing list.  So if you want
your nifty porting instructions for getting Tcl up on your Seiko wrist watch
or your pen computer to be saved for others benefit, be sure to ftp them into
the archive.

All submissions should be ftp'ed into the above subdirectory.  Please
send <URL:mailto:[email-masked]> and a short mail message stating
the filename(s) of your contribution and a brief description (for the
Index).  If you've posted some code to comp.lang.tcl or the Tcl mailing
list, and you want it to be archived at this site, please deposit it in
<URL:ftp://ftp.neosoft.com/tcl/incoming/> or mail it in a suitable form
(preferably uuencoded compressed tar file, but a shar file's OK) to
<URL:mailto:[email-masked]>.
Also, PLEASE include a {packagename}.README file which describes the
contribution.

The Tcl/Tk archive can also be accessed via the World Wide Web (WWW)
with the URL, <URL:http://web.cs.ualberta.ca/%7Ewade/HyperTcl/>.

Note: I have noticed that some authors prefer to use plain names rather than
version level type names.  This means that you should a) make note of when
you get a package, and b) check the archive occasionally to see if a newer
version of the package has appeared.

------------------------------

From: -XI- Where can I get these packages?
Subject: -C- Expect available via e-mail.

Besides being available via <URL:ftp://ftp.cme.nist.gov/pub/expect/>,
expect can also be received by email by sending the message
"send pub/expect/expect.shar.Z" to <URL:mailto:[email-masked]> .

------------------------------

From: -XI- Where can I get these packages?
Subject: -D- EMACS modes for Tcl

<URL:mailto:[email-masked]> (Sean Levy) has hacked a version of Emacs's
C mode into a tcl-mode.el.  He mentions that you must use semi-colons at the
end of each statement to get indentation to work right, but he found that
easier than doing without.

The code is on [128.2.214.236]
<URL:ftp://ftp.cs.cmu.edu/afs/cs/user/snl/pub/tcl-mode.el.z>
(don't forget binary mode) as well as
<URL:ftp://mirror.neosoft.com/pub/tcl/alcatel/distrib/tcl-mode.el.Z>.

<URL:mailto:[email-masked]> (Julian Anderson) was also working on an Emacs Tcl
minor mode to fundamental.

<URL:mailto:[email-masked]> (Chris Lindblad) has contributed tcl.el,
a Tcl mode for GNU emacs.  It's address is
<URL:ftp://mirror.neosoft.com/pub/tcl/alcatel/extensions/tcl.el>.

<URL:mailto:[email-masked]> (Tom Tromey) has contributed a tcl.el
which is better than his former tcl-help.el.  This is a modified version of
Chris Lindblad's Tcl editing mode.  This new editing mode contains the
help code, a tcl interaction mode, menus, font lock support, etc.  It
is available on the Emacs Lisp Archive at
<URL:ftp://archive.cis.ohio-state.edu/pub/emacs/elisp-archive/modes/tcl.el.Z>

and on

<URL:ftp://mirror.neosoft.com/pub/tcl/alcatel/extensions/tcl.el.gz>

<URL:mailto:[email-masked]> (Gregor Schmid) has written
a major mode for tcl scripts.  He posted tcl-mode 1.1 to gnu.emacs.sources
in March and it should be on archive.cis.ohio-state.edu - but I am not able to
locate it.

The latest version of xemacs (formerly lemacs) mentions that it has
a tcl-mode built in.

------------------------------

From: -XI- Where can I get these packages?
Subject: -E- The tk toolbox project (obsolete)

The Tk Toolbox & Toolchest project.

The Toolchest consisted of convenience routines for Tcl and Tk - a kind of a
ibc for Tcl.  The toolchest was a collection of commonly used code and
some specialized code such as file selectors, dialogs that take care of
keyboard traversal through items automatically, etc.

Unfortunately, the development effort has currently come to a stop on this
project and it is not yet known when it will be started again.

There was, at one point in the past, a mailing list for discussion of
the tk toolbox, kindly provided by Ari Lemmke.  To subscribe, one wrote a
message with the line:

X-Mn-Admin: join tktools

in the body or header of the message, and sent this message to
<URL:mailto:[email-masked]> .

Then to write to the list, messages were sent to
<URL:mailto:[email-masked]> with the line
X-Mn-Key: TKTOOLS
added to the header or the body of the message.  One especially had to remember
this step when replying to messages from the list.

For more info about the list server (mailnet), one sent
an empty message to <URL:mailto:[email-masked]> .

Intermediate snapshots were announced on this mailing list.

If you had problems or were willing to donate code or whatever,
you could contact the code maintainer (one of the three main implementors)
at <URL:mailto:[email-masked]> or <URL:mailto:[email-masked]> .

------------------------------

From: -XI- Where can I get these packages?
Subject: -F- [tv]grind definitions for tcl/tk/expect

<URL:mailto:[email-masked]> (Martin Hamilton) has come up with
a preliminary grindcap definition for Tcl, Tk and expect.  These are available
as: <URL:ftp://mirror.neosoft.com/pub/tcl/alcatel/docs/vgrind.defs>
<URL:ftp://mirror.neosoft.com/pub/tcl/alcatel/docs/vgrind.defs.README>

<URL:mailto:[email-masked]> (Andy Rabagliati) has come up with a preliminary
grindcap definition for Tcl.  Contact him for more details.

------------------------------

From: -XI- Where can I get these packages?
Subject: -G- BNF style notation for Tcl

<URL:mailto:[email-masked]> (TERRENCE MONROE BRANNON) in July of 1993,
posted some yacc code for a tcl-to-c parser.  This, along with Adam Sah's Tcl
compiler, are a couple of sources with which folk could start.

------------------------------

From: -XI- Where can I get these packages?
Subject: -H- Tcl/Tk Quick Reference Cards

<URL:mailto:[email-masked]> (Paul E. Raines) has uploaded a quick
reference card for Tcl 7.6/Tk 3.3.  You may find it at:

<URL:ftp://mirror.neosoft.com/pub/tcl/alcatel/docs/tkrefcard.tar.gz>

The reference card for Tcl 7.4/Tk 4.0 is at
<URL:ftp://ftp.slac.stanford.edu/software/TkMail/tkref-4.0.1.tar.gz>
<URL:ftp://mirror.neosoft.com/pub/tcl/alcatel/docs/tkref-4.0.1.tar.gz>

The tar contains the TeX and PostScript versions of a 3 column listing
of all widget methods and options and summaries of the wm, winfo, pack,
place and bind commands.

Jeff Tranter <URL:mailto:[email-masked]> has written a
Tcl Quick Reference document in TeX.  A PostScript version of the document is
provided in the file as well.

<URL:ftp://mirror.neosoft.com/pub/tcl/alcatel/docs/QuickRef.tar.gz>

------------------------------

From: -XI- Where can I get these packages?
Subject: -I- Hilit 19 Tcl mode

AI. Aaron Roydhouse <URL:mailto:[email-masked]> wrote, and
<URL:mailto:[email-masked]> (Julian Anderson) posted,
the following:

(hilit-set-mode-patterns
 'tcl-mode
 '(("\\s #.*$" nil comment)
   ("^#.*$" nil comment)
   ("\"[^\\\"]*\\(\\\\\\(.\\|\n\\)[^\\\"]*\\)*\"" nil string)
   ("\\$[-_a-zA-Z]+" nil varref)
   ("^source.*$" nil include)
   ("\\b\\(global\\|upvar\\)\\b" nil decl)
   ("\\b\\(error\\|debug\\)\\b" nil decl)
   ("^\\s *proc\\s +\\(\\w\\|[_']\\)+" nil defun)
   ("\\b\\(set\\|lset\\|list\\|if\\|case\\|while\\|switch\\|then\\|else\\|
for\\|foreach\\|return\\|expr\\|catch\\)\\b" nil keyword)))

Dwight Shih <URL:mailto:[email-masked]> later posted the following font
lock mode:

(defvar tcl-font-lock-keywords
  (list
   (list (concat "\\b\\("
                 (mapconcat 'identity
                            '("set" "lset" "list" "if" "case" "while"
                              "switch" "then" "else" "for" "foreach"
                              "return" "expr" "catch" "puts" "proc"
                              "trace")
                            "\\|")
                 "\\)\\b")
         1 'font-lock-keyword-face t)
   (list (concat "\\b\\("
                 (mapconcat 'identity
                            '("global" "upvar" "uplevel" "error" "debug")
                            "\\|")
                 "\\)\\b")
         1 'font-lock-type-face t)
   (list "^\\s *proc\\s +\\(\\(\\w\\|[_']\\)+\\)" 1 'font-lock-function-name-fac
e t))
  "keywords for tcl-mode")

(defun font-lock-set-defaults ()
  "Set `font-lock-keywords' to something appropriate for this mode."
  (setq font-lock-keywords
        (cond ((eq major-mode 'lisp-mode)       lisp-font-lock-keywords)
              ((eq major-mode 'emacs-lisp-mode) lisp-font-lock-keywords)
              ((eq major-mode 'c-mode)          c-font-lock-keywords)
              ((eq major-mode 'c++-c-mode)      c-font-lock-keywords)
              ((eq major-mode 'c++-mode)        c++-font-lock-keywords)
              ((eq major-mode 'tex-mode)        tex-font-lock-keywords)
              ((eq major-mode 'perl-mode)       perl-font-lock-keywords)
              ((eq major-mode 'tcl-mode)        tcl-font-lock-keywords)
              ((eq major-mode 'texinfo-mode)    texi-font-lock-keywords)
              (t nil))))

------------------------------

From: -XI- Where can I get these packages?
Subject: -J- HTML versions of Tcl man pages and FAQ.

Mike Hopkirk <URL:mailto:[email-masked]> has provided a tar archive of
HyperText Markup Language (HTML) versions of the comp.lang.tcl FAQ, the
Tcl/Tk man pages, index pages for the man pages, and a top level access
page to tie together all the above.  It is
<URL:ftp://mirror.neosoft.com/pub/tcl/alcatel/docs/tclhtml.tar.z>

Note that once these have been untarred, one can use a WorldWideWeb (WWW)
browser such as Mosaic, Lynx, etc. to begin at the Tcl.html page and read
the entire distribution.  The original source of this package can be
examined at:
<URL:http://www.sco.com/Technology/tcl/Tcl.html>

Having the package in this way provides a means for those behind a firewall
to examine the docs frozen at this point in time.  There are no commitments
to continue providing updates to this package.

The man pages provided here were made using a Perl script called
man2html originally written by <URL:mailto:[email-masked]> (Brooks Cutter)
and slightly post processed.

Tom Phelps <URL:mailto:[email-masked]> has written RosettaMan,
which allows one to translate man pages into many formats, including
HTML.  (see "tcl-faq/part4") for details.

<URL:mailto:[email-masked]> (Roger Critchlow) has built HTML versions of
the Tcl 7.5 and Tk 4.1 man pages, adding links for various commands
that wasn't already present in the original doc.  One can find these
interactively at <URL:http://www.elf.org/tcltk-man-html/contents.html>
as well as at
<URL:ftp://ftp.bdt.com/home/elf/tcltk-man-src/tcltk-man-html1.tar.gz>
and <URL:ftp://mirror.neosoft.com/pub/tcl/alcatel/docs/tcltk-man-html1.tar.gz>.

There are HTML pages for Tcl 7.4/Tk 4.0 located at
<URL:http://www.xpi.com/tix/doc/tcltkman/>.

------------------------------

From: -XI- Where can I get these packages?
Subject: -K- Japanese translation of Tk 3.6 manuals

Toshiya Kitayama <URL:mailto:[email-masked]> and [email-masked] have made
a Japanese translation of Tk 3.6 manual pages except pack-old.n available
at <URL:ftp://ftp.sra.co.jp/pub/lang/tcl/jp/tk3.6jp.man.tar.gz>.  If
you have questions or comments, send them to <URL:mailto:[email-masked]>.

------------------------------

From: -XI- Where can I get these packages?
Subject: -L- Latex styles for the Tcl/Tk Workshop 94.

Yasuro Kawata <URL:mailto:[email-masked]> released the
Latex styles as well as a sample document and sample .dvi file to the
news group.  Contact this user directly for a copy.

------------------------------

From: -XI- Where can I get these packages?
Subject: -M- Tcl References for various platforms

Duane Murphy <URL:mailto:[email-masked]>
provided a way for Macintosh users to access the information regarding
Tcl built-in commands via a tool known as ZigRef.  It can be found at
<URL:ftp://hitchhiker.space.lockheed.com/pub/TCL/TclBuiltInRef.sea.hqx>.
This version corresponds to Tcl 7.3.

The AGOCG Tcl/Tk Cookbook is available at
<URL:http://www.cis.rl.ac.uk/proj/TclTk>.  The source code examples, html,
and Postscript files are available for ftp from
<URL:ftp://ftp.cc.rl.ac.uk/pub/graphics/>.

The Cookbook is partly sponsored by the UK Advisory On Computer Graphics.
It is aimed at novice window-based interactive application developers and
newcomers to Tcl/Tk.

A commercial tutorial available online can be found at
<URL:http://www.skillshare.com/skillshare/dr/tcl/mod1.html>.  Note
that this is a commercial project - see the page for details of cost.

------------------------------

From: -XI- Where can I get these packages?
Subject: -N- The "How do I speed up a Tcl/Tk application" doc

<URL:ftp://mirror.neosoft.com/pub/tcl/alcatel/docs/speedup.doc.gz>

is a text document with examples on how to speed up Tcl/Tk applications.

Thanks to Stephen O. Lidie <URL:mailto:[email-masked]> for the work!

------------------------------

From: -XI- Where can I get these packages?
Subject: -O- http files without a WWW client

Within the various TCL FAQs there are references to items in the
form of http://host.name/path/to/file .  These are in a form
which are useful to WorldWideWeb (WWW) clients.  But for those unable
to use WWW for some reason, there is a modicum of relief.  To access
these files via email:

1. Address a message to: <URL:mailto:[email-masked]>

2. There is no need for a Subject: line.

3. In the body of the message, type:
GO http://www.w3.org/hypertext/WWW/MarkUp/html-spec/html-spec.txt

4. Any URL can be substituted for the sample above.
Eventually you should get back the file in question.

5. The only restriction is this serves text (HTML and plain) by HTTP
only, no graphics, and no FTP.

For more information about accessing internet files via e-mail, pick up
a copy of the following document:

"INTERNET BY-EMAIL"
Summary: This guide will show you how to retrieve files from FTP sites,
explore the Internet via Gopher, search for information with Archie,
Veronica, or WAIS, tap into the World-Wide Web (WWW), and even access Usenet
newsgroups using E-MAIL AS YOUR ONLY TOOL.

This document is now available from several automated mail servers. To
get the latest edition, send e-mail to one of the addresses below.
To: [email-masked] (for US/Canada/etc.)
Leave Subject blank, and enter only this line in the body of the note:
GET INTERNET BY-EMAIL NETTRAIN F=MAIL

To: [email-masked] (for Eastern US)
Leave Subject blank, and enter only this line in the body of the note:
send usenet/news.answers/internet-services/access-via-email

To: [email-masked] (for UK/Europe/etc.)
Leave Subject blank, and enter only this line in the body of the note:
send lis-iis e-access-inet.txt

You can also get the file at
<URL:ftp://ubvm.cc.buffalo.edu/NETTRAIN/INTERNET.BY-EMAIL>,
<URL:ftp://rtfm.mit.edu/pub/usenet/news.answers/internet-services/access-via-email>,
<URL:ftp://mailbase.ac.uk/pub/lists/lis-iis/files/e-access-inet.txt>

------------------------------

From: -XI- Where can I get these packages?
Subject: -P- The patch command

The patch command is used to apply updates to a source package.  It
assumes that you have the previous version of the source package in
an uncompressed format as well as a file containing one or more modifications
that need to be applied to the original code.

The GNU project's version of the patch command is the one most commonly
used on USENET.  The primary archive for this project is
<URL:ftp://prep.ai.mit.edu/pub/gnu/>.  You will find the source code
located at this FTP site.  For binary version, you will have to search
what ever the appropriate site is for your machine.

First, get a version of patch and compile and install it.  Then you
might follow a scenario such as this:

The tcl7.4/README says "apply them to the source directory"!

$ mkdir /usr/tcl74	# Pick this directory as appropriate
$ cd /usr3/tcl74
$ mv $HOME/tcl7.4.tar.gz $HOME/tcl7.4p1.patch.gz $HOME/tcl7.4p2.patch.gz $HOME/tcl7.4p3.patch.gz /usr3/tcl74
$ gzip -d < tcl7.4.tar.gz | tar xvvf -
$ cd tcl7.4
$ gzip -d < ../tcl7.4p1.patch.gz | patch -p
$ gzip -d < ../tcl7.4p2.patch.gz | patch -p
$ gzip -d < ../tcl7.4p3.patch.gz | patch -p
$ ./configure --prefix=/usr3/tcl74
$ make
$ make test
$ make install

assuming your *.gz files all reside in your $HOME directory initially.

If you already have gunzip-ed the files in a different directory (such
as /usr3/tcl74/patch/), you could use them like this:

$ cd /usr3/tcl74/tcl7.4
$ patch -p < ../patch/tcl7.4p1.patch

You will get messages from patch "hmm, this looks like" and "hunk #n
succeeded", which will scroll off your screen quite fast.  One user has
suggested that if you are using Unix, you can use the script command to
keep all of the output in a log file which you can then peruse later.

You should not get rejected, failed, or wrong version messages.  If you
get those types of messages, you may have missed a patch that needed to be
made, or may be attempting to patch a version of the files not intended to be
patched.

If the patch is being applied later, you will want to execute a "make
clean" before the make without arguments, to be sure that you have
gotten rid of any files which need to be recreated during the install
process.

You need to be careful as well trying to perform make on different
machines - if you have to switch computers between makes, you should
execute a "make distclean" followed by another configure command.
This ensures that the various assumptions made by the configuration
program are accurate.

------------------------------

From: -XI- Where can I get these packages?
Subject: -Q- Source code from published books

The source code from Brent Welch's book can be found at
<URL:ftp://ftp.prenhall.com/pub/software/welch/tkbook.tar>.

The source code from John Ousterhout's book can be found at
<URL:ftp://ftp.sunlabs.com/pub/tcl/book.examples.Z>.

The source code from Don Libes' book can be found with the
expect source code itself.  (See "tcl-faq/part04") for
more details.

------------------------------

From: -XI- Where can I get these packages?
Subject: -R- Documentation relating to Perl's Tk interface

A PostScript format overview of Perl's Tk interface is available from
<URL:ftp://mox.perl.com/pub/perl/ext/TK/tk-userguide.ps.gz>.

A remedial course in perl/Tk, based on the mini-scripts distributed in
the UserGuide.pod file, can be found at
<URL:http://w4.lns.cornell.edu/%7Epvhp/ptk/pod/>.

The perl/Tk proto-FAQ can be found at
<URL:http://w4.lns.cornell.edu/%7Epvhp/ptk/ptkFAQ.html>
Both of these are maintained by <URL:mailto:[email-masked]>
Peter Prymmer.

John Stoffel <URL:mailto:[email-masked]> wrote some thoughts comparing
Malcom Beatties tcl/tk perl extension and pTk (perl/Tk).  This can be found
at <URL:http://pubweb.bnl.gov/%7Eptk/> along with the rest of the mailing
list comments, code samples, help, etc.

------------------------------

From: -XI- Where can I get these packages?
Subject: -S- Tutorials on various subjects

There are often questions concerning X security, in particular
relating to Tk's default requirment to refuse to perform send
actions when the user is using xhost rather than xauth for
his/her security.  See <URL:http://ciac.llnl.gov/ciac/documents/ciac2316.html>
for a tutorial on X security.

Another good document on Xauth is available at
<URL:ftp://ph-meter.beckman.uiuc.edu/security/xsecurity.ps>
or
<URL:ftp://ph-meter.beckman.uiuc.edu/security/xsecurity.txt>.

Vivek Khera <URL:mailto:[email-masked]> has written a primer on
setting up your environment for xauth (by default a requirement under
Tk 3.3) in the document <URL:ftp://mirror.neosoft.com/pub/tcl/alcatel/docs/Xauthority.gz>.

Kevin Kenny <URL:mailto:[email-masked]> has also written a document
on how to resolve this situation.
<URL:http://ce-toolkit.crd.ge.com/tkxauth/>

------------------------------

End of comp.lang.tcl Frequently Asked Questions (3/5)
*****************************************************